/* Generated automatically by the program `genopinit'
from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "flags.h"
#include "insn-config.h"
#include "recog.h"
#include "expr.h"
#include "optabs.h"
#include "reload.h"

void
init_all_optabs (void)
{
#ifdef FIXUNS_TRUNC_LIKE_FIX_TRUNC
  int i, j;
#endif

  trunc_optab->handlers[QImode][SImode].insn_code = CODE_FOR_truncsiqi2;
  trunc_optab->handlers[QImode][HImode].insn_code = CODE_FOR_trunchiqi2;
  trunc_optab->handlers[HImode][SImode].insn_code = CODE_FOR_truncsihi2;
  zext_optab->handlers[DImode][QImode].insn_code = CODE_FOR_zero_extendqidi2;
  zext_optab->handlers[DImode][HImode].insn_code = CODE_FOR_zero_extendhidi2;
  zext_optab->handlers[SImode][HImode].insn_code = CODE_FOR_zero_extendhisi2;
  zext_optab->handlers[SImode][QImode].insn_code = CODE_FOR_zero_extendqisi2;
  sext_optab->handlers[DImode][QImode].insn_code = CODE_FOR_extendqidi2;
  sext_optab->handlers[DImode][HImode].insn_code = CODE_FOR_extendhidi2;
  sext_optab->handlers[DImode][SImode].insn_code = CODE_FOR_extendsidi2;
  sext_optab->handlers[HImode][QImode].insn_code = CODE_FOR_extendqihi2;
  if (HAVE_floathisf2)
    sfloat_optab->handlers[SFmode][HImode].insn_code = CODE_FOR_floathisf2;
  if (HAVE_floathidf2)
    sfloat_optab->handlers[DFmode][HImode].insn_code = CODE_FOR_floathidf2;
  if (HAVE_floatqisf2)
    sfloat_optab->handlers[SFmode][QImode].insn_code = CODE_FOR_floatqisf2;
  if (HAVE_floatqidf2)
    sfloat_optab->handlers[DFmode][QImode].insn_code = CODE_FOR_floatqidf2;
  if (HAVE_fix_truncdfsi2)
    sfixtrunc_optab->handlers[SImode][DFmode].insn_code = CODE_FOR_fix_truncdfsi2;
  if (HAVE_fix_truncdfhi2)
    sfixtrunc_optab->handlers[HImode][DFmode].insn_code = CODE_FOR_fix_truncdfhi2;
  if (HAVE_fix_truncdfqi2)
    sfixtrunc_optab->handlers[QImode][DFmode].insn_code = CODE_FOR_fix_truncdfqi2;
  if (HAVE_ftruncdf2)
    ftrunc_optab->handlers[DFmode].insn_code = CODE_FOR_ftruncdf2;
  if (HAVE_ftruncsf2)
    ftrunc_optab->handlers[SFmode].insn_code = CODE_FOR_ftruncsf2;
  if (HAVE_fixsfqi2)
    sfix_optab->handlers[QImode][SFmode].insn_code = CODE_FOR_fixsfqi2;
  if (HAVE_fixsfhi2)
    sfix_optab->handlers[HImode][SFmode].insn_code = CODE_FOR_fixsfhi2;
  if (HAVE_fixsfsi2)
    sfix_optab->handlers[SImode][SFmode].insn_code = CODE_FOR_fixsfsi2;
  if (HAVE_fixdfqi2)
    sfix_optab->handlers[QImode][DFmode].insn_code = CODE_FOR_fixdfqi2;
  if (HAVE_fixdfhi2)
    sfix_optab->handlers[HImode][DFmode].insn_code = CODE_FOR_fixdfhi2;
  if (HAVE_fixdfsi2)
    sfix_optab->handlers[SImode][DFmode].insn_code = CODE_FOR_fixdfsi2;
  add_optab->handlers[DImode].insn_code = CODE_FOR_adddi3;
  if (HAVE_addhi3)
    add_optab->handlers[HImode].insn_code = CODE_FOR_addhi3;
  if (HAVE_addqi3)
    add_optab->handlers[QImode].insn_code = CODE_FOR_addqi3;
  sub_optab->handlers[DImode].insn_code = CODE_FOR_subdi3;
  sub_optab->handlers[SImode].insn_code = CODE_FOR_subsi3;
  if (HAVE_subhi3)
    sub_optab->handlers[HImode].insn_code = CODE_FOR_subhi3;
  if (HAVE_subqi3)
    sub_optab->handlers[QImode].insn_code = CODE_FOR_subqi3;
  smul_optab->handlers[HImode].insn_code = CODE_FOR_mulhi3;
  smul_widen_optab->handlers[SImode].insn_code = CODE_FOR_mulhisi3;
  umul_widen_optab->handlers[SImode].insn_code = CODE_FOR_umulhisi3;
  if (HAVE_divmodhi4)
    sdivmod_optab->handlers[HImode].insn_code = CODE_FOR_divmodhi4;
  if (HAVE_udivmodhi4)
    udivmod_optab->handlers[HImode].insn_code = CODE_FOR_udivmodhi4;
  if (HAVE_anddi3)
    and_optab->handlers[DImode].insn_code = CODE_FOR_anddi3;
  if (HAVE_andhi3)
    and_optab->handlers[HImode].insn_code = CODE_FOR_andhi3;
  if (HAVE_andqi3)
    and_optab->handlers[QImode].insn_code = CODE_FOR_andqi3;
  if (HAVE_iordi3)
    ior_optab->handlers[DImode].insn_code = CODE_FOR_iordi3;
  if (HAVE_iorhi3)
    ior_optab->handlers[HImode].insn_code = CODE_FOR_iorhi3;
  if (HAVE_iorqi3)
    ior_optab->handlers[QImode].insn_code = CODE_FOR_iorqi3;
  if (HAVE_xordi3)
    xor_optab->handlers[DImode].insn_code = CODE_FOR_xordi3;
  if (HAVE_xorhi3)
    xor_optab->handlers[HImode].insn_code = CODE_FOR_xorhi3;
  if (HAVE_xorqi3)
    xor_optab->handlers[QImode].insn_code = CODE_FOR_xorqi3;
  if (HAVE_neghi2)
    neg_optab->handlers[HImode].insn_code = CODE_FOR_neghi2;
  if (HAVE_negqi2)
    neg_optab->handlers[QImode].insn_code = CODE_FOR_negqi2;
  if (HAVE_sqrtsf2)
    sqrt_optab->handlers[SFmode].insn_code = CODE_FOR_sqrtsf2;
  if (HAVE_sqrtdf2)
    sqrt_optab->handlers[DFmode].insn_code = CODE_FOR_sqrtdf2;
  if (HAVE_one_cmpldi2)
    one_cmpl_optab->handlers[DImode].insn_code = CODE_FOR_one_cmpldi2;
  if (HAVE_one_cmplhi2)
    one_cmpl_optab->handlers[HImode].insn_code = CODE_FOR_one_cmplhi2;
  if (HAVE_one_cmplqi2)
    one_cmpl_optab->handlers[QImode].insn_code = CODE_FOR_one_cmplqi2;
  ashl_optab->handlers[SImode].insn_code = CODE_FOR_ashlsi3;
  if (HAVE_ashlhi3)
    ashl_optab->handlers[HImode].insn_code = CODE_FOR_ashlhi3;
  if (HAVE_ashlqi3)
    ashl_optab->handlers[QImode].insn_code = CODE_FOR_ashlqi3;
  ashr_optab->handlers[SImode].insn_code = CODE_FOR_ashrsi3;
  if (HAVE_ashrhi3)
    ashr_optab->handlers[HImode].insn_code = CODE_FOR_ashrhi3;
  if (HAVE_ashrqi3)
    ashr_optab->handlers[QImode].insn_code = CODE_FOR_ashrqi3;
  lshr_optab->handlers[SImode].insn_code = CODE_FOR_lshrsi3;
  if (HAVE_lshrhi3)
    lshr_optab->handlers[HImode].insn_code = CODE_FOR_lshrhi3;
  if (HAVE_lshrqi3)
    lshr_optab->handlers[QImode].insn_code = CODE_FOR_lshrqi3;
  if (HAVE_rotlsi3)
    rotl_optab->handlers[SImode].insn_code = CODE_FOR_rotlsi3;
  if (HAVE_rotlhi3)
    rotl_optab->handlers[HImode].insn_code = CODE_FOR_rotlhi3;
  if (HAVE_rotlqi3)
    rotl_optab->handlers[QImode].insn_code = CODE_FOR_rotlqi3;
  if (HAVE_rotrsi3)
    rotr_optab->handlers[SImode].insn_code = CODE_FOR_rotrsi3;
  if (HAVE_rotrhi3)
    rotr_optab->handlers[HImode].insn_code = CODE_FOR_rotrhi3;
  if (HAVE_rotrqi3)
    rotr_optab->handlers[QImode].insn_code = CODE_FOR_rotrqi3;
  bcc_gen_fctn[EQ] = gen_beq;
  bcc_gen_fctn[NE] = gen_bne;
  bcc_gen_fctn[GT] = gen_bgt;
  bcc_gen_fctn[GTU] = gen_bgtu;
  bcc_gen_fctn[LT] = gen_blt;
  bcc_gen_fctn[LTU] = gen_bltu;
  bcc_gen_fctn[GE] = gen_bge;
  bcc_gen_fctn[GEU] = gen_bgeu;
  bcc_gen_fctn[LE] = gen_ble;
  bcc_gen_fctn[LEU] = gen_bleu;
  if (HAVE_bordered)
    bcc_gen_fctn[ORDERED] = gen_bordered;
  if (HAVE_bunordered)
    bcc_gen_fctn[UNORDERED] = gen_bunordered;
  if (HAVE_buneq)
    bcc_gen_fctn[UNEQ] = gen_buneq;
  if (HAVE_bunge)
    bcc_gen_fctn[UNGE] = gen_bunge;
  if (HAVE_bungt)
    bcc_gen_fctn[UNGT] = gen_bungt;
  if (HAVE_bunle)
    bcc_gen_fctn[UNLE] = gen_bunle;
  if (HAVE_bunlt)
    bcc_gen_fctn[UNLT] = gen_bunlt;
  if (HAVE_bltgt)
    bcc_gen_fctn[LTGT] = gen_bltgt;
  if (HAVE_extendsfxf2)
    sext_optab->handlers[XFmode][SFmode].insn_code = CODE_FOR_extendsfxf2;
  if (HAVE_extenddfxf2)
    sext_optab->handlers[XFmode][DFmode].insn_code = CODE_FOR_extenddfxf2;
  if (HAVE_truncxfdf2)
    trunc_optab->handlers[DFmode][XFmode].insn_code = CODE_FOR_truncxfdf2;
  if (HAVE_truncxfsf2)
    trunc_optab->handlers[SFmode][XFmode].insn_code = CODE_FOR_truncxfsf2;
  if (HAVE_floatsixf2)
    sfloat_optab->handlers[XFmode][SImode].insn_code = CODE_FOR_floatsixf2;
  if (HAVE_floathixf2)
    sfloat_optab->handlers[XFmode][HImode].insn_code = CODE_FOR_floathixf2;
  if (HAVE_floatqixf2)
    sfloat_optab->handlers[XFmode][QImode].insn_code = CODE_FOR_floatqixf2;
  if (HAVE_ftruncxf2)
    ftrunc_optab->handlers[XFmode].insn_code = CODE_FOR_ftruncxf2;
  if (HAVE_fixxfqi2)
    sfix_optab->handlers[QImode][XFmode].insn_code = CODE_FOR_fixxfqi2;
  if (HAVE_fixxfhi2)
    sfix_optab->handlers[HImode][XFmode].insn_code = CODE_FOR_fixxfhi2;
  if (HAVE_fixxfsi2)
    sfix_optab->handlers[SImode][XFmode].insn_code = CODE_FOR_fixxfsi2;
  if (HAVE_addxf3)
    addv_optab->handlers[XFmode].insn_code =
    add_optab->handlers[XFmode].insn_code = CODE_FOR_addxf3;
  if (HAVE_subxf3)
    subv_optab->handlers[XFmode].insn_code =
    sub_optab->handlers[XFmode].insn_code = CODE_FOR_subxf3;
  if (HAVE_mulxf3)
    smulv_optab->handlers[XFmode].insn_code =
    smul_optab->handlers[XFmode].insn_code = CODE_FOR_mulxf3;
  if (HAVE_divxf3)
    sdiv_optab->handlers[XFmode].insn_code = CODE_FOR_divxf3;
  if (HAVE_sqrtxf2)
    sqrt_optab->handlers[XFmode].insn_code = CODE_FOR_sqrtxf2;
  if (HAVE_sinsf2)
    sin_optab->handlers[SFmode].insn_code = CODE_FOR_sinsf2;
  if (HAVE_sindf2)
    sin_optab->handlers[DFmode].insn_code = CODE_FOR_sindf2;
  if (HAVE_sinxf2)
    sin_optab->handlers[XFmode].insn_code = CODE_FOR_sinxf2;
  if (HAVE_cossf2)
    cos_optab->handlers[SFmode].insn_code = CODE_FOR_cossf2;
  if (HAVE_cosdf2)
    cos_optab->handlers[DFmode].insn_code = CODE_FOR_cosdf2;
  if (HAVE_cosxf2)
    cos_optab->handlers[XFmode].insn_code = CODE_FOR_cosxf2;
  tst_optab->handlers[DImode].insn_code = CODE_FOR_tstdi;
  tst_optab->handlers[SImode].insn_code = CODE_FOR_tstsi;
  tst_optab->handlers[HImode].insn_code = CODE_FOR_tsthi;
  tst_optab->handlers[QImode].insn_code = CODE_FOR_tstqi;
  if (HAVE_tstsf)
    tst_optab->handlers[SFmode].insn_code = CODE_FOR_tstsf;
  if (HAVE_tstdf)
    tst_optab->handlers[DFmode].insn_code = CODE_FOR_tstdf;
  cmp_optab->handlers[DImode].insn_code = CODE_FOR_cmpdi;
  cmp_optab->handlers[SImode].insn_code = CODE_FOR_cmpsi;
  if (HAVE_cmphi)
    cmp_optab->handlers[HImode].insn_code = CODE_FOR_cmphi;
  if (HAVE_cmpqi)
    cmp_optab->handlers[QImode].insn_code = CODE_FOR_cmpqi;
  if (HAVE_cmpdf)
    cmp_optab->handlers[DFmode].insn_code = CODE_FOR_cmpdf;
  if (HAVE_cmpsf)
    cmp_optab->handlers[SFmode].insn_code = CODE_FOR_cmpsf;
  mov_optab->handlers[SImode].insn_code = CODE_FOR_movsi;
  mov_optab->handlers[HImode].insn_code = CODE_FOR_movhi;
  movstrict_optab->handlers[HImode].insn_code = CODE_FOR_movstricthi;
  mov_optab->handlers[QImode].insn_code = CODE_FOR_movqi;
  movstrict_optab->handlers[QImode].insn_code = CODE_FOR_movstrictqi;
  if (HAVE_pushqi1)
    push_optab->handlers[QImode].insn_code = CODE_FOR_pushqi1;
  mov_optab->handlers[SFmode].insn_code = CODE_FOR_movsf;
  mov_optab->handlers[DFmode].insn_code = CODE_FOR_movdf;
  mov_optab->handlers[BFmode].insn_code = CODE_FOR_movbf;
  mov_optab->handlers[XFmode].insn_code = CODE_FOR_movxf;
  mov_optab->handlers[DImode].insn_code = CODE_FOR_movdi;
  zext_optab->handlers[DImode][SImode].insn_code = CODE_FOR_zero_extendsidi2;
  if (HAVE_zero_extendqihi2)
    zext_optab->handlers[HImode][QImode].insn_code = CODE_FOR_zero_extendqihi2;
  sext_optab->handlers[SImode][HImode].insn_code = CODE_FOR_extendhisi2;
  if (HAVE_extendqisi2)
    sext_optab->handlers[SImode][QImode].insn_code = CODE_FOR_extendqisi2;
  if (HAVE_extendsfdf2)
    sext_optab->handlers[DFmode][SFmode].insn_code = CODE_FOR_extendsfdf2;
  if (HAVE_truncdfsf2)
    trunc_optab->handlers[SFmode][DFmode].insn_code = CODE_FOR_truncdfsf2;
  if (HAVE_floatsisf2)
    sfloat_optab->handlers[SFmode][SImode].insn_code = CODE_FOR_floatsisf2;
  if (HAVE_floatsidf2)
    sfloat_optab->handlers[DFmode][SImode].insn_code = CODE_FOR_floatsidf2;
  add_optab->handlers[SImode].insn_code = CODE_FOR_addsi3;
  if (HAVE_adddf3)
    addv_optab->handlers[DFmode].insn_code =
    add_optab->handlers[DFmode].insn_code = CODE_FOR_adddf3;
  if (HAVE_addsf3)
    addv_optab->handlers[SFmode].insn_code =
    add_optab->handlers[SFmode].insn_code = CODE_FOR_addsf3;
  if (HAVE_subdf3)
    subv_optab->handlers[DFmode].insn_code =
    sub_optab->handlers[DFmode].insn_code = CODE_FOR_subdf3;
  if (HAVE_subsf3)
    subv_optab->handlers[SFmode].insn_code =
    sub_optab->handlers[SFmode].insn_code = CODE_FOR_subsf3;
  if (HAVE_mulsi3)
    smul_optab->handlers[SImode].insn_code = CODE_FOR_mulsi3;
  if (HAVE_umulsidi3)
    umul_widen_optab->handlers[DImode].insn_code = CODE_FOR_umulsidi3;
  if (HAVE_mulsidi3)
    smul_widen_optab->handlers[DImode].insn_code = CODE_FOR_mulsidi3;
  if (HAVE_umulsi3_highpart)
    umul_highpart_optab->handlers[SImode].insn_code = CODE_FOR_umulsi3_highpart;
  if (HAVE_smulsi3_highpart)
    smul_highpart_optab->handlers[SImode].insn_code = CODE_FOR_smulsi3_highpart;
  if (HAVE_muldf3)
    smulv_optab->handlers[DFmode].insn_code =
    smul_optab->handlers[DFmode].insn_code = CODE_FOR_muldf3;
  if (HAVE_mulsf3)
    smulv_optab->handlers[SFmode].insn_code =
    smul_optab->handlers[SFmode].insn_code = CODE_FOR_mulsf3;
  if (HAVE_divdf3)
    sdiv_optab->handlers[DFmode].insn_code = CODE_FOR_divdf3;
  if (HAVE_divsf3)
    sdiv_optab->handlers[SFmode].insn_code = CODE_FOR_divsf3;
  if (HAVE_divmodsi4)
    sdivmod_optab->handlers[SImode].insn_code = CODE_FOR_divmodsi4;
  if (HAVE_udivmodsi4)
    udivmod_optab->handlers[SImode].insn_code = CODE_FOR_udivmodsi4;
  and_optab->handlers[SImode].insn_code = CODE_FOR_andsi3;
  ior_optab->handlers[SImode].insn_code = CODE_FOR_iorsi3;
  xor_optab->handlers[SImode].insn_code = CODE_FOR_xorsi3;
  neg_optab->handlers[DImode].insn_code = CODE_FOR_negdi2;
  neg_optab->handlers[SImode].insn_code = CODE_FOR_negsi2;
  negv_optab->handlers[SFmode].insn_code =
    neg_optab->handlers[SFmode].insn_code = CODE_FOR_negsf2;
  negv_optab->handlers[DFmode].insn_code =
    neg_optab->handlers[DFmode].insn_code = CODE_FOR_negdf2;
  absv_optab->handlers[SFmode].insn_code =
    abs_optab->handlers[SFmode].insn_code = CODE_FOR_abssf2;
  absv_optab->handlers[DFmode].insn_code =
    abs_optab->handlers[DFmode].insn_code = CODE_FOR_absdf2;
  one_cmpl_optab->handlers[SImode].insn_code = CODE_FOR_one_cmplsi2;
  if (HAVE_ashldi3)
    ashl_optab->handlers[DImode].insn_code = CODE_FOR_ashldi3;
  if (HAVE_ashrdi3)
    ashr_optab->handlers[DImode].insn_code = CODE_FOR_ashrdi3;
  if (HAVE_lshrdi3)
    lshr_optab->handlers[DImode].insn_code = CODE_FOR_lshrdi3;
  setcc_gen_code[EQ] = CODE_FOR_seq;
  setcc_gen_code[NE] = CODE_FOR_sne;
  setcc_gen_code[GT] = CODE_FOR_sgt;
  setcc_gen_code[GTU] = CODE_FOR_sgtu;
  setcc_gen_code[LT] = CODE_FOR_slt;
  setcc_gen_code[LTU] = CODE_FOR_sltu;
  setcc_gen_code[GE] = CODE_FOR_sge;
  setcc_gen_code[GEU] = CODE_FOR_sgeu;
  setcc_gen_code[LE] = CODE_FOR_sle;
  setcc_gen_code[LEU] = CODE_FOR_sleu;
  if (HAVE_sordered)
    setcc_gen_code[ORDERED] = CODE_FOR_sordered;
  if (HAVE_sunordered)
    setcc_gen_code[UNORDERED] = CODE_FOR_sunordered;
  if (HAVE_suneq)
    setcc_gen_code[UNEQ] = CODE_FOR_suneq;
  if (HAVE_sunge)
    setcc_gen_code[UNGE] = CODE_FOR_sunge;
  if (HAVE_sungt)
    setcc_gen_code[UNGT] = CODE_FOR_sungt;
  if (HAVE_sunle)
    setcc_gen_code[UNLE] = CODE_FOR_sunle;
  if (HAVE_sunlt)
    setcc_gen_code[UNLT] = CODE_FOR_sunlt;
  if (HAVE_sltgt)
    setcc_gen_code[LTGT] = CODE_FOR_sltgt;
  if (HAVE_tstxf)
    tst_optab->handlers[XFmode].insn_code = CODE_FOR_tstxf;
  if (HAVE_cmpxf)
    cmp_optab->handlers[XFmode].insn_code = CODE_FOR_cmpxf;
  negv_optab->handlers[XFmode].insn_code =
    neg_optab->handlers[XFmode].insn_code = CODE_FOR_negxf2;
  absv_optab->handlers[XFmode].insn_code =
    abs_optab->handlers[XFmode].insn_code = CODE_FOR_absxf2;

#ifdef FIXUNS_TRUNC_LIKE_FIX_TRUNC
  /* This flag says the same insns that convert to a signed fixnum
     also convert validly to an unsigned one.  */
  for (i = 0; i < NUM_MACHINE_MODES; i++)
    for (j = 0; j < NUM_MACHINE_MODES; j++)
      ufixtrunc_optab->handlers[i][j].insn_code
      = sfixtrunc_optab->handlers[i][j].insn_code;
#endif
}
