/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../../download/gcc.ti/gcc/config/m68k/m68k.md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tree.h"
#include "tm_p.h"
#include "function.h"
#include "insn-config.h"
#include "recog.h"
#include "real.h"
#include "output.h"
#include "flags.h"
#include "hard-reg-set.h"
#include "resource.h"
#include "toplev.h"
#include "reload.h"
#include "regs.h"

static inline int
general_src_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 27 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  if (TARGET_PCREL
      && GET_CODE (op) == MEM
      && (GET_CODE (XEXP (op, 0)) == SYMBOL_REF
	  || GET_CODE (XEXP (op, 0)) == LABEL_REF
	  || GET_CODE (XEXP (op, 0)) == CONST))
    return 1;
  return general_operand (op, mode);
}

int
general_src_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT || GET_CODE (op) == CONST_DOUBLE || GET_CODE (op) == CONST || GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == LABEL_REF || GET_CODE (op) == SUBREG || GET_CODE (op) == REG || GET_CODE (op) == MEM) && (
(general_src_operand_1 (op, mode)));
}

static inline int
nonimmediate_src_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 43 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  if (TARGET_PCREL && GET_CODE (op) == MEM
      && (GET_CODE (XEXP (op, 0)) == SYMBOL_REF
	  || GET_CODE (XEXP (op, 0)) == LABEL_REF
	  || GET_CODE (XEXP (op, 0)) == CONST))
    return 1;
  return nonimmediate_operand (op, mode);
}

int
nonimmediate_src_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SUBREG || GET_CODE (op) == REG || GET_CODE (op) == MEM) && (
(nonimmediate_src_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
memory_src_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 57 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  if (TARGET_PCREL && GET_CODE (op) == MEM
      && (GET_CODE (XEXP (op, 0)) == SYMBOL_REF
	  || GET_CODE (XEXP (op, 0)) == LABEL_REF
	  || GET_CODE (XEXP (op, 0)) == CONST))
    return 1;
  return memory_operand (op, mode);
}

int
memory_src_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SUBREG || GET_CODE (op) == MEM) && (
(memory_src_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
not_sp_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 70 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  return op != stack_pointer_rtx && nonimmediate_operand (op, mode);
}

int
not_sp_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SUBREG || GET_CODE (op) == REG || GET_CODE (op) == MEM) && (
(not_sp_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
pcrel_address_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 80 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  return (GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == LABEL_REF
	  || GET_CODE (op) == CONST);
}

int
pcrel_address (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == LABEL_REF || GET_CODE (op) == CONST) && (
(pcrel_address_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
const_uint32_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 92 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  /* It doesn't make sense to ask this question with a mode that is
     not larger than 32 bits.  */
  if (GET_MODE_BITSIZE (mode) <= 32)
    abort ();

#if HOST_BITS_PER_WIDE_INT > 32
  /* All allowed constants will fit a CONST_INT.  */
  return (GET_CODE (op) == CONST_INT
	  && (INTVAL (op) >= 0 && INTVAL (op) <= 0xffffffffL));
#else
  return (GET_CODE (op) == CONST_INT
	  && INTVAL (op) >= 0);
#endif
}

int
const_uint32_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
(const_uint32_operand_1 (op, mode)));
}

static inline int
const_sint32_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 114 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  /* It doesn't make sense to ask this question with a mode that is
     not larger than 32 bits.  */
  if (GET_MODE_BITSIZE (mode) <= 32)
    abort ();

  /* All allowed constants will fit a CONST_INT.  */
  return (GET_CODE (op) == CONST_INT
	  && (INTVAL (op) >= (-0x7fffffff - 1) && INTVAL (op) <= 0x7fffffff));
}

int
const_sint32_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
(const_sint32_operand_1 (op, mode)));
}

static inline int
valid_dbcc_comparison_p_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 132 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  return valid_dbcc_comparison_p_2 (op, mode);
}

int
valid_dbcc_comparison_p (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == EQ || GET_CODE (op) == NE || GET_CODE (op) == GTU || GET_CODE (op) == LTU || GET_CODE (op) == GEU || GET_CODE (op) == LEU || GET_CODE (op) == GT || GET_CODE (op) == LT || GET_CODE (op) == GE || GET_CODE (op) == LE) && (
(valid_dbcc_comparison_p_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
extend_operator_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 140 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  if (mode != VOIDmode && GET_MODE (op) != mode)
    return 0;
  switch (GET_CODE (op))
    {
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      return 1;
    default:
      return 0;
    }
}

int
extend_operator (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SIGN_EXTEND || GET_CODE (op) == ZERO_EXTEND) && (
(extend_operator_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
symbolic_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 158 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  switch (GET_CODE (op))
    {
    case SYMBOL_REF:
    case LABEL_REF:
      return true;

    case CONST:
      op = XEXP (op, 0);
      return ((GET_CODE (XEXP (op, 0)) == SYMBOL_REF
	       || GET_CODE (XEXP (op, 0)) == LABEL_REF)
	      && GET_CODE (XEXP (op, 1)) == CONST_INT);

#if 0 /* Deleted, with corresponding change in m68k.h,
	 so as to fit the specs.  No CONST_DOUBLE is ever symbolic.  */
    case CONST_DOUBLE:
      return GET_MODE (op) == mode;
#endif

    default:
      return false;
    }
}

int
symbolic_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == LABEL_REF || GET_CODE (op) == CONST) && (
(symbolic_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
post_inc_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 186 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  return MEM_P (op) && GET_CODE (XEXP (op, 0)) == POST_INC;
}

int
post_inc_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && (
(post_inc_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
pre_dec_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 194 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  return MEM_P (op) && GET_CODE (XEXP (op, 0)) == PRE_DEC;
}

int
pre_dec_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && (
(pre_dec_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
extended_address_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 202 "../../../download/gcc.ti/gcc/config/m68k/predicates.md"
{
  if (TARGET_PCREL && CONSTANT_ADDRESS_P (op))
    return 1;
  return address_operand (op, mode);
}

int
extended_address_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT || GET_CODE (op) == CONST_DOUBLE || GET_CODE (op) == CONST || GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == LABEL_REF || GET_CODE (op) == SUBREG || GET_CODE (op) == REG || GET_CODE (op) == MEM || GET_CODE (op) == PLUS || GET_CODE (op) == MINUS || GET_CODE (op) == MULT) && (
(extended_address_operand_1 (op, mode)));
}

