/* Generated automatically by the program `genextract'
from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "toplev.h"

static rtx junk ATTRIBUTE_UNUSED;
void
insn_extract (rtx insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED;

  switch (INSN_CODE (insn))
    {
    case -1:
      fatal_insn_not_found (insn);

    case 515:
    case 514:
    case 513:
    case 512:
    case 511:
    case 510:
    case 509:
    case 508:
    case 507:
    case 506:
    case 505:
      for (i = XVECLEN (pat, 0) - 1; i >= 0; i--)
          ro[i] = *(ro_loc[i] = &XVECEXP (pat, 0, i));
      break;

    case 406:  /* cosxf2 */
    case 405:  /* cosdf2 */
    case 404:  /* cossf2 */
    case 403:  /* sinxf2 */
    case 402:  /* sindf2 */
    case 401:  /* sinsf2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 407:  /* trap */
    case 366:  /* return */
    case 365:  /* nop */
    case 364:  /* blockage */
      break;

    case 359:  /* *m68k.md:6278 */
    case 358:  /* *m68k.md:6239 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[1] = 0;
      break;

    case 357:  /* *m68k.md:6211 */
    case 356:  /* *m68k.md:6187 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[1] = 0;
      break;

    case 355:  /* *m68k.md:6162 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 354:  /* *m68k.md:6153 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 353:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 352:  /* *bltgt_rev */
    case 351:  /* *bunlt_rev */
    case 350:  /* *bunle_rev */
    case 349:  /* *bunge_rev */
    case 348:  /* *buneq_rev */
    case 347:  /* *bunordered_rev */
    case 346:  /* *bordered_rev */
    case 345:  /* *m68k.md:6044 */
    case 344:  /* *m68k.md:6030 */
    case 343:  /* *m68k.md:6019 */
    case 342:  /* *m68k.md:6005 */
    case 341:  /* *m68k.md:5994 */
    case 340:  /* *m68k.md:5980 */
    case 339:  /* *m68k.md:5969 */
    case 338:  /* *m68k.md:5955 */
    case 337:  /* *m68k.md:5941 */
    case 336:  /* *m68k.md:5927 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 335:  /* bltgt */
    case 334:  /* bunlt */
    case 333:  /* bunle */
    case 332:  /* bungt */
    case 331:  /* bunge */
    case 330:  /* buneq */
    case 329:  /* bunordered */
    case 328:  /* bordered */
    case 327:  /* bleu */
    case 326:  /* ble */
    case 325:  /* bgeu */
    case 324:  /* bge */
    case 323:  /* bltu */
    case 322:  /* blt */
    case 321:  /* bgtu */
    case 320:  /* bgt */
    case 319:  /* bne */
    case 318:  /* beq */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 317:  /* blt0_di */
    case 316:  /* bge0_di */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 315:  /* bne0_di */
    case 314:  /* beq0_di */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 291:  /* scc_di_5200 */
    case 290:  /* scc_di */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 289:  /* scc0_di_5200 */
    case 288:  /* scc0_di */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 287:  /* *m68k.md:5073 */
    case 286:  /* *m68k.md:5048 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 284:  /* *m68k.md:5016 */
    case 283:  /* *m68k.md:5005 */
    case 279:  /* *m68k.md:4948 */
    case 278:  /* *m68k.md:4937 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      break;

    case 277:  /* *m68k.md:4922 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2);
      recog_data.dup_num[2] = 2;
      break;

    case 282:  /* *m68k.md:4986 */
    case 281:  /* *m68k.md:4978 */
    case 276:  /* *m68k.md:4903 */
    case 275:  /* *m68k.md:4887 */
    case 274:  /* *m68k.md:4848 */
    case 272:  /* *m68k.md:4794 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 273:  /* *m68k.md:4833 */
    case 271:  /* *m68k.md:4779 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 285:  /* *m68k.md:5027 */
    case 280:  /* *m68k.md:4967 */
    case 270:  /* *m68k.md:4740 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 269:  /* *m68k.md:4725 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 268:  /* *m68k.md:4700 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 0), 2), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 0), 2), 1));
      break;

    case 267:  /* bclrmemqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 0), 2), 1));
      break;

    case 266:  /* *m68k.md:4674 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 265:  /* bsetmemqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 236:  /* ashrdi_const32_mem */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 244:  /* subreg1lshrdi_const32 */
    case 234:  /* subregsi1ashrdi_const32 */
    case 233:  /* subreghi1ashrdi_const32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 221:  /* ashldi_sexthi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 220:  /* ashldi_extsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 219:  /* *m68k.md:3978 */
    case 217:  /* *m68k.md:3966 */
    case 206:  /* *m68k.md:3718 */
    case 204:  /* *m68k.md:3706 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 167:  /* udivmodhi4 */
    case 166:  /* divmodhi4 */
    case 165:  /* *m68k.md:3071 */
    case 164:  /* *m68k.md:3055 */
    case 163:  /* *m68k.md:3031 */
    case 162:  /* *m68k.md:3015 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 145:  /* const_smulsi3_highpart */
    case 143:  /* const_umulsi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      break;

    case 144:  /* *m68k.md:2784 */
    case 142:  /* *m68k.md:2741 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      break;

    case 141:  /* *m68k.md:2705 */
    case 139:  /* *m68k.md:2670 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 140:  /* *m68k.md:2694 */
    case 138:  /* *m68k.md:2655 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1), 0);
      recog_data.dup_num[1] = 2;
      break;

    case 188:  /* iorsi_zexthi_ashl16 */
    case 136:  /* umulhisi3 */
    case 132:  /* mulhisi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 115:  /* subdi_dishl32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 114:  /* subdi_sexthishl32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 392:  /* *m68k.md:7105 */
    case 391:  /* *m68k.md:7098 */
    case 390:  /* *m68k.md:7091 */
    case 384:  /* *m68k.md:7041 */
    case 383:  /* *m68k.md:7034 */
    case 382:  /* *m68k.md:7027 */
    case 152:  /* *m68k.md:2881 */
    case 151:  /* *m68k.md:2870 */
    case 150:  /* *m68k.md:2859 */
    case 148:  /* *m68k.md:2827 */
    case 147:  /* *m68k.md:2820 */
    case 146:  /* *m68k.md:2813 */
    case 112:  /* *m68k.md:2310 */
    case 111:  /* *m68k.md:2303 */
    case 110:  /* *m68k.md:2296 */
    case 108:  /* *m68k.md:2271 */
    case 107:  /* *m68k.md:2264 */
    case 106:  /* *m68k.md:2257 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 198:  /* *m68k.md:3629 */
    case 195:  /* *m68k.md:3608 */
    case 187:  /* *m68k.md:3448 */
    case 184:  /* *m68k.md:3427 */
    case 177:  /* *m68k.md:3284 */
    case 174:  /* *m68k.md:3263 */
    case 105:  /* *m68k.md:2227 */
    case 102:  /* *m68k.md:2132 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 264:  /* *m68k.md:4651 */
    case 262:  /* *m68k.md:4637 */
    case 259:  /* *m68k.md:4608 */
    case 257:  /* *m68k.md:4578 */
    case 254:  /* *m68k.md:4537 */
    case 252:  /* *m68k.md:4523 */
    case 243:  /* *m68k.md:4350 */
    case 241:  /* *m68k.md:4336 */
    case 230:  /* *m68k.md:4170 */
    case 228:  /* *m68k.md:4156 */
    case 197:  /* *m68k.md:3622 */
    case 194:  /* *m68k.md:3601 */
    case 186:  /* *m68k.md:3441 */
    case 183:  /* *m68k.md:3420 */
    case 176:  /* *m68k.md:3277 */
    case 173:  /* *m68k.md:3256 */
    case 122:  /* *m68k.md:2480 */
    case 120:  /* *m68k.md:2466 */
    case 104:  /* *m68k.md:2204 */
    case 101:  /* *m68k.md:2083 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 396:  /* *m68k.md:7137 */
    case 395:  /* *m68k.md:7130 */
    case 394:  /* *m68k.md:7123 */
    case 388:  /* *m68k.md:7073 */
    case 387:  /* *m68k.md:7066 */
    case 386:  /* *m68k.md:7059 */
    case 160:  /* *m68k.md:2977 */
    case 159:  /* *m68k.md:2966 */
    case 158:  /* *m68k.md:2955 */
    case 156:  /* *m68k.md:2930 */
    case 155:  /* *m68k.md:2923 */
    case 154:  /* *m68k.md:2916 */
    case 129:  /* *m68k.md:2547 */
    case 128:  /* *m68k.md:2540 */
    case 127:  /* *m68k.md:2533 */
    case 125:  /* *m68k.md:2508 */
    case 124:  /* *m68k.md:2501 */
    case 123:  /* *m68k.md:2494 */
    case 118:  /* *m68k.md:2451 */
    case 99:  /* *m68k.md:2020 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 397:  /* divxf3 */
    case 393:  /* mulxf3 */
    case 389:  /* subxf3 */
    case 385:  /* addxf3 */
    case 363:  /* *m68k.md:6412 */
    case 362:  /* *m68k.md:6397 */
    case 263:  /* rotrqi3 */
    case 261:  /* rotrhi3 */
    case 260:  /* rotrsi3 */
    case 258:  /* rotlqi3 */
    case 256:  /* rotlhi3 */
    case 255:  /* rotlsi3 */
    case 253:  /* lshrqi3 */
    case 251:  /* lshrhi3 */
    case 250:  /* lshrsi3 */
    case 249:  /* lshrsi_17_24 */
    case 246:  /* lshrdi_const */
    case 242:  /* ashrqi3 */
    case 240:  /* ashrhi3 */
    case 239:  /* ashrsi3 */
    case 237:  /* ashrdi_const */
    case 232:  /* *m68k.md:4188 */
    case 229:  /* ashlqi3 */
    case 227:  /* ashlhi3 */
    case 226:  /* ashlsi3 */
    case 225:  /* ashlsi_17_24 */
    case 223:  /* ashldi_const */
    case 196:  /* xorqi3 */
    case 193:  /* xorhi3 */
    case 192:  /* xorsi3_5200 */
    case 191:  /* xorsi3_internal */
    case 190:  /* xordi3 */
    case 185:  /* iorqi3 */
    case 182:  /* iorhi3 */
    case 181:  /* iorsi3_5200 */
    case 180:  /* iorsi3_internal */
    case 179:  /* iordi3 */
    case 175:  /* andqi3 */
    case 172:  /* andhi3 */
    case 171:  /* andsi3_5200 */
    case 170:  /* andsi3_internal */
    case 169:  /* *andsi3_split */
    case 168:  /* anddi3 */
    case 161:  /* *m68k.md:2988 */
    case 157:  /* *m68k.md:2937 */
    case 153:  /* *m68k.md:2892 */
    case 149:  /* *m68k.md:2834 */
    case 135:  /* *m68k.md:2612 */
    case 134:  /* *m68k.md:2604 */
    case 131:  /* mulhi3 */
    case 130:  /* *m68k.md:2554 */
    case 126:  /* *m68k.md:2515 */
    case 121:  /* subqi3 */
    case 119:  /* subhi3 */
    case 117:  /* subsi3 */
    case 113:  /* *m68k.md:2317 */
    case 109:  /* *m68k.md:2278 */
    case 103:  /* addqi3 */
    case 100:  /* addhi3 */
    case 98:  /* *addsi3_5200 */
    case 97:  /* *addsi3_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 96:  /* addsi_lshrsi_31 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 1;
      break;

    case 116:  /* subdi3 */
    case 95:  /* adddi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 189:  /* iorsi_zext */
    case 178:  /* iordi_zext */
    case 137:  /* *m68k.md:2630 */
    case 133:  /* *m68k.md:2587 */
    case 94:  /* adddi_dishl32 */
    case 93:  /* adddi_dilshr32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 92:  /* adddi_sexthishl32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 91:  /* adddi_lshrdi_63 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
      recog_data.dup_num[0] = 1;
      break;

    case 82:  /* fix_truncdfqi2 */
    case 81:  /* fix_truncdfhi2 */
    case 80:  /* fix_truncdfsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 65:  /* extendplussidi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 400:  /* sqrtxf2 */
    case 399:  /* absxf2_68881 */
    case 398:  /* negxf2_68881 */
    case 381:  /* fixxfsi2 */
    case 380:  /* fixxfhi2 */
    case 379:  /* fixxfqi2 */
    case 378:  /* ftruncxf2 */
    case 377:  /* floatqixf2 */
    case 376:  /* floathixf2 */
    case 375:  /* floatsixf2 */
    case 374:  /* truncxfsf2 */
    case 373:  /* truncxfdf2 */
    case 372:  /* extenddfxf2 */
    case 371:  /* extendsfxf2 */
    case 248:  /* lshrsi_16 */
    case 247:  /* lshrsi_31 */
    case 245:  /* lshrdi_const32 */
    case 238:  /* ashrsi_31 */
    case 235:  /* ashrdi_const32 */
    case 231:  /* ashrsi_16 */
    case 224:  /* ashlsi_16 */
    case 222:  /* ashldi_const32 */
    case 218:  /* one_cmplqi2 */
    case 216:  /* one_cmplhi2 */
    case 215:  /* one_cmplsi2_5200 */
    case 214:  /* one_cmplsi2_internal */
    case 213:  /* one_cmpldi2 */
    case 212:  /* *m68k.md:3907 */
    case 211:  /* *m68k.md:3865 */
    case 210:  /* sqrtdf2 */
    case 209:  /* sqrtsf2 */
    case 208:  /* *m68k.md:3798 */
    case 207:  /* *m68k.md:3751 */
    case 205:  /* negqi2 */
    case 203:  /* neghi2 */
    case 202:  /* negsi2_5200 */
    case 201:  /* negsi2_internal */
    case 200:  /* negdi2_5200 */
    case 199:  /* negdi2_internal */
    case 90:  /* fixdfsi2 */
    case 89:  /* fixdfhi2 */
    case 88:  /* fixdfqi2 */
    case 87:  /* fixsfsi2 */
    case 86:  /* fixsfhi2 */
    case 85:  /* fixsfqi2 */
    case 84:  /* ftruncsf2 */
    case 83:  /* ftruncdf2 */
    case 79:  /* floatqidf2 */
    case 78:  /* floatqisf2 */
    case 77:  /* floathidf2 */
    case 76:  /* floathisf2 */
    case 75:  /* *m68k.md:1671 */
    case 74:  /* *m68k.md:1659 */
    case 73:  /* *m68k.md:1638 */
    case 72:  /* *m68k.md:1627 */
    case 71:  /* *m68k.md:1588 */
    case 70:  /* *68k_extendqisi2 */
    case 69:  /* *cfv4_extendqisi2 */
    case 68:  /* extendqihi2 */
    case 67:  /* *68k_extendhisi2 */
    case 66:  /* *cfv4_extendhisi2 */
    case 64:  /* extendsidi2 */
    case 63:  /* extendhidi2 */
    case 62:  /* extendqidi2 */
    case 61:  /* zero_extendqisi2 */
    case 60:  /* *zero_extendqisi2_cfv4 */
    case 59:  /* *zero_extendqihi2 */
    case 58:  /* zero_extendhisi2 */
    case 57:  /* *zero_extendhisi2_cf */
    case 56:  /* *zero_extendsidi2 */
    case 55:  /* zero_extendhidi2 */
    case 54:  /* zero_extendqidi2 */
    case 53:  /* *zero_extend_dec */
    case 52:  /* *zero_extend_inc */
    case 51:  /* truncsihi2 */
    case 50:  /* trunchiqi2 */
    case 49:  /* truncsiqi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 37:  /* *m68k.md:799 */
    case 36:  /* *m68k.md:793 */
    case 33:  /* *m68k.md:763 */
    case 32:  /* *m68k.md:757 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 313:  /* *fsole_1 */
    case 312:  /* *fsolt_1 */
    case 311:  /* *fsoge_1 */
    case 310:  /* *fsogt_1 */
    case 309:  /* *sltgt_1 */
    case 308:  /* *sunlt_1 */
    case 307:  /* *sunle_1 */
    case 306:  /* *sungt_1 */
    case 305:  /* *sunge_1 */
    case 304:  /* *suneq_1 */
    case 303:  /* *sunordered_1 */
    case 302:  /* *sordered_1 */
    case 301:  /* *m68k.md:5314 */
    case 300:  /* *m68k.md:5299 */
    case 299:  /* *m68k.md:5278 */
    case 298:  /* *m68k.md:5263 */
    case 297:  /* *m68k.md:5242 */
    case 296:  /* *m68k.md:5227 */
    case 295:  /* *m68k.md:5206 */
    case 294:  /* *m68k.md:5191 */
    case 293:  /* *m68k.md:5170 */
    case 292:  /* *m68k.md:5149 */
    case 24:  /* movsi_const0 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 22:  /* *m68k.md:576 */
    case 21:  /* *m68k.md:556 */
    case 20:  /* *m68k.md:546 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 19:  /* *m68k.md:532 */
    case 18:  /* *m68k.md:520 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 2), 1), 0));
      break;

    case 17:  /* *m68k.md:506 */
    case 16:  /* *m68k.md:496 */
    case 15:  /* *m68k.md:483 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 2), 1));
      break;

    case 370:  /* *m68k.md:6875 */
    case 14:  /* *m68k.md:459 */
    case 13:  /* *m68k.md:432 */
    case 12:  /* *m68k.md:404 */
    case 11:  /* *m68k.md:378 */
    case 10:  /* *m68k.md:350 */
    case 9:  /* *m68k.md:326 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 8:  /* *m68k.md:289 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 369:  /* *m68k.md:6859 */
    case 367:  /* indirect_jump */
    case 29:  /* *m68k.md:725 */
    case 7:  /* *m68k.md:267 */
    case 6:  /* *m68k.md:248 */
    case 5:  /* *m68k.md:234 */
    case 4:  /* *m68k.md:222 */
    case 3:  /* *m68k.md:201 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 2:  /* *m68k.md:164 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 408:  /* conditional_trap */
    case 368:  /* *m68k.md:6491 */
    case 361:  /* *m68k.md:6371 */
    case 360:  /* *m68k.md:6356 */
    case 48:  /* pushasi */
    case 47:  /* *m68k.md:1203 */
    case 46:  /* *m68k.md:1163 */
    case 45:  /* *m68k.md:1149 */
    case 44:  /* *m68k.md:1110 */
    case 43:  /* *m68k.md:1070 */
    case 42:  /* *m68k.md:1031 */
    case 41:  /* *m68k.md:964 */
    case 40:  /* *m68k.md:927 */
    case 39:  /* *m68k.md:913 */
    case 38:  /* *m68k.md:868 */
    case 35:  /* *m68k.md:781 */
    case 34:  /* *m68k.md:775 */
    case 31:  /* *m68k.md:745 */
    case 30:  /* *m68k.md:739 */
    case 28:  /* *m68k.md:717 */
    case 27:  /* *movsi_cfv4 */
    case 26:  /* *movsi_cf */
    case 25:  /* *m68k.md:689 */
    case 23:  /* pushexthisi_const */
    case 1:  /* pushdi */
    case 0:  /* *m68k.md:134 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    default:
      gcc_unreachable ();
    }
}
